function [a,MM]=BAGfunc(N,m,display_flag,lambda_0,lambda_N);
if(nargin<5) lambda_N=0; end;
if(nargin<4) lambda_0=0; end;
fa=gammaln(1:2*N+1); %use gammaln instead of factorial for accuracy, speed
Ni=fa(N+1)-fa(1:N+1)-fliplr(fa(1:N+1));
p=(0:N*5)/(N*5);
p=p(2:length(p)-1);
lp=log(p); lq=fliplr(lp);
P=zeros(N+1,length(p)+2);
for(i=0:N) %build matrix of Bernoulli polynomials
    P(i+1,2:columns(P)-1)=Ni(i+1)+(i*lp+(N-i)*lq);
end;
P=exp(P);
P(2:rows(P)-1,[1 columns(P)])=zeros(N-1,2);
P(1,1)=1;
P(rows(P),columns(P))=1;
P(rows(P),1)=0;
P(1,columns(P))=0;
p=[0 p 1];
f=zeros(size(p));
ff=find(p<=1/m);
f(ff)=m;
ff=find(p>1/m);
f(ff)=p(ff).^-1; %f is the weighting function, as in the paper
X=m*P';
XX=X'*X; %self-products of integrals (sums, here)
XY=m*X'*(-log(p.^p))';
DD=2*eye(N+1)-diag(ones(1,N),1)-diag(ones(1,N),-1);
DD(1)=1;
DD(N+1,N+1)=1;
AA=XX+N*DD;
AA=AA.*(abs(AA)>max(max(abs(AA)))*10^-7);
AA(1)=AA(1)+lambda_0;
AA(N+1,N+1)=AA(N+1,N+1)+lambda_N;
if(0)
    [u,d,v]=svd(AA);
    figure(66); plot(log(diag(d))); %plot log spectrum; AA starts getting singular (according to matlab default eps values) around N=500 if N/m < .5
    svs=0; %inverse by svd; set svs=j to throw out j svds
    i=N+1-svs;
    invd=zeros(size(d));
    invd(1+(0:i-1)*(N+2))=d(1+(0:i-1)*(N+2)).^-1;
    a=v*invd*u'*XY;
else
    a=pinv(AA)*XY; %or just use inv() instead
end;
MM=[];
mesh=10;
p=(0:N*mesh)/(N*mesh);
p=p(2:length(p)-1);
lp=log(p); lq=fliplr(lp);
P=zeros(N+1,length(p)+2);
for(i=0:N)
    P(i+1,2:columns(P)-1)=Ni(i+1)+(i*lp+(N-i)*lq);
end;
P=exp(P);
P(2:rows(P)-1,[1 columns(P)])=zeros(N-1,2);
P(1,1)=1;
P(rows(P),columns(P))=1;
P(rows(P),1)=0;
P(1,columns(P))=0;
p=[0 p 1];
f=zeros(size(p));
ff=find(p<=1/m);
f(ff)=m;
ff=find(p>1/m);
f(ff)=p(ff).^-1;
Pn=a'*P;
maxbias=m*max(abs(Pn+log(p.^p)));
figure(22); plot(p,Pn+log(p.^p));
MM=sqrt(maxbias^2+N*(max(abs(diff(a))))^2)/log(2);
if(display_flag)
    disp(sprintf('m=%i; N=%i; max mse<%f bits',m,N,MM));
end;
