#!/bin/tcsh -f

# This is just a record, honest, but it does run.
# Grabs the number of inferred states from the info files in
# the current directory (*_BIC_picked_info). The first
# line grabs the coordinate part of the name and the number of states
# and stores them in the file given in $1.
# The second line grabs the unique'd list of the number of states,
# takes an outer product, sorts and uniques, and then produces matlab
# code to compute the Paninski coefficients for that number of states
# and the time series length given in $2.
#

echo $1 $2

grep -n '^Number of Infer' *_BIC_picked_info |  perl -F: -ane '$F[0] =~ s/^reg12_([^.]+)\.dts.*$/$1/; printf "%12s %4d\n", $F[0], $F[3];' |  sort -k 2,2n  > $1

echo "pcoefs = [];\nnstates = [];"; grep -n '^Number of Infer' *_BIC_picked_info | \
 perl -F: -lane 'print $F[3];' | \
 sort -n | uniq | perl -e 'while( <STDIN> ) { chomp; push @states, $_; }' -e 'for( my $i = 0; $i < scalar(@states); ++$i ) { for( my $j = 0; $j <= $i; ++$j ) { push @pairs, $states[$i] * $states[$j]; } }' -e 'print join( "\n", @pairs ), "\n";' | sort -n | uniq | perl -le 'while( <STDIN> ) { chomp; print qq{nstates = [nstates, $_]; pcoefs = [pcoefs, paninski( $_, $ARGV[0] )];}; }' $2; echo 'save("-ascii","paninski.coefs","pcoefs");'; echo 'save("-ascii","paninski.states","nstates");'

# in the above paninski() should return a column vector

# Produces list of uniqued products in ascending order
# grep -n '^Number of Infer' *_BIC_picked_info | \
#  perl -F: -lane 'print $F[3];' | \
#  sort -n | uniq | perl -e 'while( <STDIN> ) { chomp; push @states, $_; }' -e 'for( my $i = 0; $i < scalar(@states); ++$i ) { for( my $j = 0; $j <= $i; ++$j ) { push @pairs, $states[$i] * $states[$j]; } }' -e 'print join( "\n", @pairs ), "\n";' | sort -n | uniq 
# 
