function [best_a,best_MM]=modBUBfunc(N,m,k_max,display_flag,lambda_0);
if(nargin<5) lambda_0=0; end;
if(N<20)
    [best_a,best_MM]=BAGfunc(N,m,display_flag,lambda_0);
else
    if(k_max>N) disp('restricting k_max to be less than N...'); end
    c=80;      % constant number to restrict the binomial coefficients in the P matrix: values are effectively zero for larger N
    c=ceil(min(N,c*max(N/m,1)));
    s=30;
    mesh=200;
    eps=(N^-1)*10^-10;
    Ni=gammaln(N+1)-gammaln(1:c+1)-gammaln(N+1-(0:c));
    p=logspace(log10((1e-4)/N),log10(min(1,s/N)-eps),mesh); %logarithmic mesh makes L2 norm a better approximation of the max
    lp=log(p); 
    lq=log(1-p);
    P=exp(repmat(Ni',1,length(p))+(0:c)'*lp+(N-(0:c))'*lq);
 
    epsm=(m^-1)*10^-10;
    sm=s;
    meshm=mesh;
    pm=epsm:min(1,sm/m)/meshm:min(1,sm/m)-epsm;
    lpm=log(pm); lqm=log(1-pm);
    
    Pm=exp(repmat(Ni',1,length(pm))+(0:c)'*lpm+(N-(0:c))'*lqm);
    f=zeros(size(pm));
    f(find(pm<=1/m))=m;
    ff=find(pm>1/m);
    f(ff)=pm(ff).^-1;
    
    a=(0:N)/N;
    a=-log(a.^a)+(1-a)*.5/N;
    a=a';
    mda=max(abs(diff(a)));
    
    best_MM=Inf;
    for k=1:min(k_max,N)
        h_mm = a(k+1:c+1)' * P(k+1:c+1,:);
        XX=(m^2)*(P(1:k,:)*P(1:k,:)');
        XY=(m^2)*(P(1:k,:)*(-log(p.^p)-h_mm)');
        XY(k)=XY(k)+N*a(k);
        DD=2*eye(k)-diag(ones(1,k-1),1)-diag(ones(1,k-1),-1);
        DD(1)=1;
        DD(k,k)=1;
        AA=XX+N*DD;
        AA(1)=AA(1)+lambda_0;
        AA(k,k)=AA(k,k)+N;
        a(1:k)=pinv(AA)*XY;
        
        B=m*(a(1:c+1)'*P+log(p.^p));
        maxbias=max(abs(B));
        V1=(((0:c)/N)'.*((a(1:c+1)-[0;a(1:c)]).^2))'*Pm;
        mmda=max(mda,max(abs(diff(a(1:min(k+2,length(a)))))));
        MM=sqrt(maxbias^2+N*min(mmda^2,4*max(f.*V1)))/log(2);
        
        if(MM<best_MM)
            best_MM=MM;
            best_a=a;
            best_B=B;
            best_V1=V1;
            disp(sprintf('current best k = %i; best max error = %2.3f',k,best_MM));
        end;
    end;
    if(0)
        opt_a=fminunc('BUBerrfunc',best_a(1:19),[],best_a(20:length(best_a)),m,P,p,c,N,Pm,k,f,mda);
        best_a(1:19)=opt_a;
    end;
    
    best_B=m*(best_a(1:c+1)'*P+log(p.^p));
    maxbias=max(abs(best_B));
    V1=(((0:c)/N)'.*((best_a(1:c+1)-[0;best_a(1:c)]).^2))'*Pm;
    mmda=max(mda,max(abs(diff(best_a(1:min(k+2,length(best_a)))))));
    best_MM=sqrt(maxbias^2+N*min(mmda^2,4*max(f.*V1)))/log(2);
    
    if(display_flag)
        disp(sprintf('m=%i; N=%i; max mse<%2.4f bits; max bias<%2.4f',m,N,best_MM,max(abs(best_B))/log(2)));
        figure(88);
        subplot(2,1,1)
        plot(p,best_B/log(2)); axis tight; title('bias function'); xlabel('p');
        subplot(2,1,2);
        plot(pm,4*N*f.*best_V1); axis tight; title('variance (Steele) function'); xlabel('pm');
    end;
end;
